package dev.peerat.parser.java;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.function.Predicate;

import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.VisitorBag;

public class JavaProject implements JavaElement{
	
	private List<JavaFile> files;
	
	public JavaProject(){
		this.files = new ArrayList<>();
	}
	
	public void addFile(JavaFile file){
		this.files.add(file);
	}

	public List<JavaFile> getFiles(){
		return this.files;
	}
	
	@Override
	public <E extends JavaElement> E find(Predicate<JavaElement> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Predicate<JavaElement> finder, Collection<E> collector) {
		
	}

	@Override
	public VisitorBag visit(Visitor<JavaElement> visitor){
		VisitorBag bag = new VisitorBag();
		for(JavaFile file : this.files) bag.merge(file.visit(visitor));
		return bag;
	}
	
	
}
