package dev.peerat.parser.java.printer;

import dev.peerat.parser.java.operation.ReturnOperation;
import dev.peerat.parser.java.value.Value;

public class JavaOperationPrinter{
	
	public static class JavaOperationReturnPrinter extends JavaPrinter<ReturnOperation>{

		@Override
		public void print(ReturnOperation element, Writer writer, String buffer, JavaPrintProvider provider)throws Exception {
			writer.write(buffer+"return");
			Value value = element.getValue();
			if(value == null){
				writer.write(";");
				return;
			}
			writer.write(" ");
			provider.getPrinter(value).print(value, writer, "", provider);
			writer.write(";");
		}
		
	}

}
