package dev.peerat.parser.visitor;

import static dev.peerat.parser.java.visitor.JavaVisitor.*;
import static dev.peerat.parser.visitor.Operator.*;

import java.util.List;
import java.util.Map;

import dev.peerat.parser.java.Import;
import dev.peerat.parser.java.JavaFile;
import dev.peerat.parser.java.JavaParser;
import dev.peerat.parser.java.JavaProject;
import dev.peerat.parser.java.Class;

public class Example {
	
	public static void main(String[] args) throws Exception{
		
		JavaParser parser = new JavaParser();
		JavaFile container = new JavaFile();
		parser.parse("package dev.peerat.test; import a; import b; public class C{} public class D{}",
				container);
		
		JavaProject project = new JavaProject();
		project.addFile(container);
		
		System.out.println(project.visit(
				allFile().clazz(key(allClass())).imp(value(allImport()))
				).toList());
		
//		Map<Class, List<Import>> map = project.visit(
//				and(
//					allFile().imp(value(allImport()))
//					,
//					allFile().clazz(key(allClass()))
//				)).toMapValues();
//		System.out.println(map);
	}

}
