package dev.peerat.parser.java.visitor.value;

import dev.peerat.parser.java.value.ArrayValue;
import dev.peerat.parser.visitor.VisitorBag;
import dev.peerat.parser.java.visitor.JavaVisitor;

public class JavaArrayValueVisitor extends JavaVisitor<ArrayValue> {

	public JavaArrayValueVisitor(boolean propagate){
		super(ArrayValue.class, propagate);
	}

	@Override
	public VisitorBag visitElement(ArrayValue element) {
		VisitorBag bag = new VisitorBag();
		bag.compute(element);
		return bag;
	}
}
